<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>BinaryInputArchive.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute</a> &gt; <span class="el_source">BinaryInputArchive.java</span></div><h1>BinaryInputArchive.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute;

import java.io.DataInput;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;

/**
 *
 */
public class BinaryInputArchive implements InputArchive {
    static public final String UNREASONBLE_LENGTH= &quot;Unreasonable length = &quot;;
    private DataInput in;
    
    static public BinaryInputArchive getArchive(InputStream strm) {
<span class="fc" id="L34">        return new BinaryInputArchive(new DataInputStream(strm));</span>
    }
    
    static private class BinaryIndex implements Index {
        private int nelems;
<span class="fc" id="L39">        BinaryIndex(int nelems) {</span>
<span class="fc" id="L40">            this.nelems = nelems;</span>
<span class="fc" id="L41">        }</span>
        public boolean done() {
<span class="fc bfc" id="L43" title="All 2 branches covered.">            return (nelems &lt;= 0);</span>
        }
        public void incr() {
<span class="fc" id="L46">            nelems--;</span>
<span class="fc" id="L47">        }</span>
    }
    /** Creates a new instance of BinaryInputArchive */
<span class="fc" id="L50">    public BinaryInputArchive(DataInput in) {</span>
<span class="fc" id="L51">        this.in = in;</span>
<span class="fc" id="L52">    }</span>
    
    public byte readByte(String tag) throws IOException {
<span class="fc" id="L55">        return in.readByte();</span>
    }
    
    public boolean readBool(String tag) throws IOException {
<span class="fc" id="L59">        return in.readBoolean();</span>
    }
    
    public int readInt(String tag) throws IOException {
<span class="fc" id="L63">        return in.readInt();</span>
    }
    
    public long readLong(String tag) throws IOException {
<span class="fc" id="L67">        return in.readLong();</span>
    }
    
    public float readFloat(String tag) throws IOException {
<span class="nc" id="L71">        return in.readFloat();</span>
    }
    
    public double readDouble(String tag) throws IOException {
<span class="nc" id="L75">        return in.readDouble();</span>
    }
    
    public String readString(String tag) throws IOException {
<span class="fc" id="L79">    	int len = in.readInt();</span>
<span class="pc bpc" id="L80" title="1 of 2 branches missed.">    	if (len == -1) return null;</span>
<span class="fc" id="L81">        checkLength(len);</span>
<span class="fc" id="L82">    	byte b[] = new byte[len];</span>
<span class="fc" id="L83">    	in.readFully(b);</span>
<span class="fc" id="L84">    	return new String(b, &quot;UTF8&quot;);</span>
    }
    
<span class="fc" id="L87">    static public final int maxBuffer = Integer.getInteger(&quot;jute.maxbuffer&quot;, 0xfffff);</span>

    public byte[] readBuffer(String tag) throws IOException {
<span class="fc" id="L90">        int len = readInt(tag);</span>
<span class="fc bfc" id="L91" title="All 2 branches covered.">        if (len == -1) return null;</span>
<span class="fc" id="L92">        checkLength(len);</span>
<span class="fc" id="L93">        byte[] arr = new byte[len];</span>
<span class="fc" id="L94">        in.readFully(arr);</span>
<span class="fc" id="L95">        return arr;</span>
    }
    
    public void readRecord(Record r, String tag) throws IOException {
<span class="fc" id="L99">        r.deserialize(this, tag);</span>
<span class="fc" id="L100">    }</span>
    
<span class="fc" id="L102">    public void startRecord(String tag) throws IOException {}</span>
    
<span class="fc" id="L104">    public void endRecord(String tag) throws IOException {}</span>
    
    public Index startVector(String tag) throws IOException {
<span class="fc" id="L107">        int len = readInt(tag);</span>
<span class="fc bfc" id="L108" title="All 2 branches covered.">        if (len == -1) {</span>
<span class="fc" id="L109">        	return null;</span>
        }
<span class="fc" id="L111">		return new BinaryIndex(len);</span>
    }
    
<span class="fc" id="L114">    public void endVector(String tag) throws IOException {}</span>
    
    public Index startMap(String tag) throws IOException {
<span class="nc" id="L117">        return new BinaryIndex(readInt(tag));</span>
    }
    
<span class="nc" id="L120">    public void endMap(String tag) throws IOException {}</span>

    // Since this is a rough sanity check, add some padding to maxBuffer to
    // make up for extra fields, etc. (otherwise e.g. clients may be able to
    // write buffers larger than we can read from disk!)
    private void checkLength(int len) throws IOException {
<span class="pc bpc" id="L126" title="1 of 4 branches missed.">        if (len &lt; 0 || len &gt; maxBuffer + 1024) {</span>
<span class="fc" id="L127">            throw new IOException(UNREASONBLE_LENGTH + len);</span>
        }
<span class="fc" id="L129">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>